 function varargout = StartRampTool(varargin)
% STARTRAMPTOOL MATLAB code for StartRampTool.fig
%      STARTRAMPTOOL, by itself, creates a new STARTRAMPTOOL or raises the existing
%      singleton*.
%
%      H = STARTRAMPTOOL returns the handle to a new STARTRAMPTOOL or the handle to
%      the existing singleton*.
%
%      STARTRAMPTOOL('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in STARTRAMPTOOL.M with the given input arguments.
%
%      STARTRAMPTOOL('Property','Value',...) creates a new STARTRAMPTOOL or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before StartRampTool_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to StartRampTool_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help StartRampTool

% Last Modified by GUIDE v2.5 08-Jan-2018 13:12:16

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @StartRampTool_OpeningFcn, ...
                   'gui_OutputFcn',  @StartRampTool_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before StartRampTool is made visible.
function StartRampTool_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to StartRampTool (see VARARGIN)

% Choose default command line output for StartRampTool
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes StartRampTool wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = StartRampTool_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in checkbox1.
function checkbox1_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox1


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

catchflag = false; 
ntower = str2double(get(handles.ntowers,'String'));
nfrct = str2double(get(handles.nforecasts,'String'));

set(hObject,'Enable','off')
pause(0.01)
frmtstr = get(get(handles.fileformat,'SelectedObject'),'String');
switch frmtstr(1:4)
    case 'Text'
        ncflag = false;
    case 'Netc'
        ncflag = true;
end

inpstr = get(get(handles.inputlength,'SelectedObject'),'String');
switch inpstr(1:9)
    case 'Forecast '
        try
            path1 = [pwd '/Input_Forecast_Run/'];
            [WindObs2,WindMod2] = reading_windfiles2(ntower,path1,ncflag);
            frcthrs = ceil((WindObs2(end,1,1) - WindObs2(1,1,1))*24);
            if frcthrs < nfrct
                catchflag = true;
            end
        catch
            catchflag = true;  
        end
        
    case 'Stitching'
        try
            path1 = [pwd '/Input_Stitching/'];
            [WindObs,WindMod] = reading_windfiles(ntower,nfrct,path1,ncflag);
        catch
            catchflag = true;  
        end
end

if str2num(get(handles.bonus,'String')) > 1 || str2num(get(handles.bonus,'String')) < 0
   warndlg('BonusWeight must be a number from 0 to 1'); 
   set(hObject,'Enable','on')
elseif str2num(get(handles.forecast,'String')) >= nfrct
   warndlg('Forecast Horizon is a number not bigger than the number of provided forecasts');
   set(hObject,'Enable','on')
elseif catchflag
   warndlg('Number of Towers or Number of Forecasts don''t match input data');
   set(hObject,'Enable','on')
else
    set(hObject,'Enable','off')
    pause(0.01)
    
    switch get(get(handles.aggregation,'SelectedObject'),'String')
        case 'Over towers aggregate'
            aggregation = 1;
        case 'Over individual towers'
            aggregation = 0;
    end
    
    switch get(get(handles.config,'SelectedObject'),'String')
        case 'Up&Down Ramps'
            configuration = 1;
        case 'Up Ramps'
            configuration = 2;
        case 'Down Ramps'
            configuration = 3;
    end
    switch get(get(handles.method,'SelectedObject'),'String')
        case 'Fixed Time'
            method = 1;
        case 'Min-Max'
            method = 2;
        case 'Derivative'
            method = 3;
    end
    switch get(get(handles.weight,'SelectedObject'),'String')
        case 'Weighted'
            WeightFlag = true;
        case 'Unweighted'
            WeightFlag = false;  
    end
    switch get(get(handles.data,'SelectedObject'),'String')
        case 'Speed Data'
            PowerFlag = false;
        case 'Power Data'
            PowerFlag = true;  
    end
    switch get(handles.addplot,'Value')
        case 1
            addplot = true;
        case 0
            addplot = false;
    end
    forecast = str2double(get(handles.forecast,'String'))+1;
    bonusweight = str2double(get(handles.bonus,'String'));
    switch inpstr(1:9)
        case 'Forecast '
            path2 = [pwd '/Output_Forecast_Run_Method/'];
            mkdir(path2)
            run_RAMP2;
        case 'Stitching'
            path2 = [pwd '/Output_Stitching_Method/'];
            mkdir(path2)
            run_RAMP;
    end
    set(hObject,'Enable','on')
end



function edit2_Callback(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit2 as text
%        str2double(get(hObject,'String')) returns contents of edit2 as a double
S = get(hObject,'string');
S1 = S;
S1(ismember(S, '-+eEgG.,')) = ' ';
S2 = sprintf('%g', sscanf(S1, '%g', 1));
set(hObject, 'String', S2);
if ~all(ismember(S, '1234567890'))
  warndlg('Forecast Horizon is a positive integer')
end

% --- Executes during object creation, after setting all properties.
function edit2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
handles.forecast = hObject;
guidata(hObject,handles);


function edit1_Callback(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit1 as text
%        str2double(get(hObject,'String')) returns contents of edit1 as a double
S = get(hObject,'string');
S(ismember(S, '-+eEgG')) = ' ';
S2 = sprintf('%g', sscanf(S, '%g', 1));
if str2double(S2) > 1
    S2 = '0';
    warndlg('BonusWeight must be a number from 0 to 1')
end
set(hObject, 'String', S2);
if ~all(ismember(S, '.1234567890'))
  warndlg('BonusWeight must be a number from 0 to 1')
end

% --- Executes during object creation, after setting all properties.
function edit1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
handles.bonus = hObject;
guidata(hObject,handles);


% --- Executes on button press in radiobutton1.
function radiobutton1_Callback(hObject, eventdata, handles)
% hObject    handle to radiobutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radiobutton1


% --- Executes on button press in radiobutton2.
function radiobutton2_Callback(hObject, eventdata, handles)
% hObject    handle to radiobutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radiobutton2


% --- Executes on button press in checkbox2.
function checkbox2_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox2


% --- Executes on button press in radiobutton10.
function radiobutton10_Callback(hObject, eventdata, handles)
% hObject    handle to radiobutton10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radiobutton10


% --- Executes on button press in radiobutton9.
function radiobutton9_Callback(hObject, eventdata, handles)
% hObject    handle to radiobutton9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radiobutton9


% --- Executes during object creation, after setting all properties.
function checkbox1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to checkbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
handles.addplot = hObject;
guidata(hObject,handles);


% --- Executes during object creation, after setting all properties.
function uipanel3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to uipanel3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
handles.weight = hObject;
guidata(hObject,handles);


% --- Executes during object creation, after setting all properties.
function uipanel7_CreateFcn(hObject, eventdata, handles)
% hObject    handle to uipanel7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
handles.data = hObject;
guidata(hObject,handles);


% --- Executes during object creation, after setting all properties.
function uipanel5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to uipanel5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
handles.config = hObject;
guidata(hObject,handles);


% --- Executes during object creation, after setting all properties.
function uipanel4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to uipanel4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
handles.method = hObject;
guidata(hObject,handles);


% --- Executes during object creation, after setting all properties.
function pushbutton1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
handles.button = hObject;
guidata(hObject,handles);


% --- Executes when selected object is changed in uipanel5.
function uipanel5_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in uipanel5 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)


% --- Executes during object creation, after setting all properties.
function uipanel8_CreateFcn(hObject, eventdata, handles)
% hObject    handle to uipanel8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
handles.weight = hObject;
guidata(hObject,handles);


% --- Executes during object creation, after setting all properties.
function uipanel9_CreateFcn(hObject, eventdata, handles)
% hObject    handle to uipanel9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
handles.data = hObject;
guidata(hObject,handles);


% --- Executes during object creation, after setting all properties.
function figure1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
handles.figure = hObject;
guidata(hObject,handles);


% --- Executes when selected object is changed in uipanel10.
function uipanel10_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in uipanel10 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)


% --- Executes during object creation, after setting all properties.
function uipanel10_CreateFcn(hObject, eventdata, handles)
% hObject    handle to uipanel10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
handles.aggregation = hObject;
guidata(hObject,handles);


% --- Executes during object deletion, before destroying properties.
function figure1_DeleteFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)



function edit3_Callback(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit3 as text
%        str2double(get(hObject,'String')) returns contents of edit3 as a double
S = get(hObject,'string');
S1 = S;
S1(ismember(S, '-+eEgG.,')) = ' ';
S2 = sprintf('%g', sscanf(S1, '%g', 1));
set(hObject, 'String', S2);
if ~all(ismember(S, '1234567890'))
  warndlg('Number of Towers is a positive integer')
end

% --- Executes during object creation, after setting all properties.
function edit3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
handles.ntowers = hObject;
guidata(hObject,handles);



function edit4_Callback(hObject, eventdata, handles)
% hObject    handle to edit4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit4 as text
%        str2double(get(hObject,'String')) returns contents of edit4 as a double
S = get(hObject,'string');
S1 = S;
S1(ismember(S, '-+eEgG.,')) = ' ';
S2 = sprintf('%g', sscanf(S1, '%g', 1));
set(hObject, 'String', S2);
if ~all(ismember(S, '1234567890'))
  warndlg('Number of Forecasts is a positive integer')
end



% --- Executes during object creation, after setting all properties.
function edit4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
handles.nforecasts = hObject;
guidata(hObject,handles);


% --- Executes on button press in radiobutton13.
function radiobutton13_Callback(hObject, eventdata, handles)
% hObject    handle to radiobutton13 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radiobutton13


% --- Executes during object creation, after setting all properties.
function radiobutton13_CreateFcn(hObject, eventdata, handles)
% hObject    handle to radiobutton13 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes during object creation, after setting all properties.
function uipanel11_CreateFcn(hObject, eventdata, handles)
% hObject    handle to uipanel11 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
handles.inputlength = hObject;
guidata(hObject,handles);


% --- Executes during object creation, after setting all properties.
function uipanel12_CreateFcn(hObject, eventdata, handles)
% hObject    handle to uipanel12 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
handles.fileformat = hObject;
guidata(hObject,handles);
