function [ramp,eventupall,eventdnall] = Ramp_Derivative_Test(Power, Window, Thresh, dayfr, forecast, itwr, RampFlag, Aggflag,path2)
% find Ramps with Derivative method

ramp  = NaN(1,5,2);
timestep = (dayfr(2)-dayfr(1))*60*24;
windowpt = fix(Window/round(timestep)) + 1;
halfwindow = fix(windowpt/2);
Kthresh = Thresh/(windowpt - 1);
npoint = size(Power,1);
for imodel = 1:2
    power = Power(:,imodel);
    powererrup = NaN(size(power));
    powererrdn = NaN(size(power));
    powerder = NaN(size(power));
    powersigma = NaN(size(power));
    for ipoint = 1:npoint - windowpt + 1
        [~,k,~,sigma] = derivative(1:windowpt, power(ipoint:ipoint+windowpt - 1));
        powerder(ipoint+halfwindow)= k;
        if k > Kthresh
           powererrup(ipoint + halfwindow) = 1; 
        end
        if k < -Kthresh
           powererrdn(ipoint + halfwindow) = -1; 
        end
        powersigma(ipoint + halfwindow) = sigma;
    end
    
    powerdnext = powererrdn;
    powerupext = powererrup;
    for ipoint = halfwindow+1:npoint - halfwindow
       if isnan(powererrdn(ipoint-1)) && powererrdn(ipoint)== -1
          maxpoint = NaN;
          del = 0;
          for i = 1:halfwindow
              pwrdel = power(ipoint - i) - power(ipoint);
              if pwrdel > del
                 maxpoint = i;
                 del = pwrdel;
              end
          end
          if ~isnan(maxpoint)
              powerdnext(ipoint - maxpoint:ipoint - 1) = -1;
          end
       end
       if powererrdn(ipoint)==-1 && isnan(powererrdn(ipoint + 1))
          minpoint = NaN;
          del = 0; 
          for i = 1:halfwindow
             pwrdel = power(ipoint + i) - power(ipoint);
             if pwrdel < del
                 minpoint = i;
                 del = pwrdel;
             end
          end
          if ~isnan(minpoint)
             powerdnext(ipoint+1:ipoint+minpoint) = -1;
          end
       end
       if isnan(powererrup(ipoint-1)) && powererrup(ipoint)== 1
          minpoint = NaN;
          del = 0;
          for i = 1:halfwindow
              pwrdel = power(ipoint - i) - power(ipoint);
              if pwrdel < del
                 minpoint = i;
                 del = pwrdel;
              end
          end
          if ~isnan(minpoint)
              powerupext(ipoint - minpoint:ipoint - 1) = 1;
          end
       end
       if powererrup(ipoint)==1 && isnan(powererrup(ipoint + 1))
          maxpoint = NaN;
          del = 0; 
          for i = 1:halfwindow
             pwrdel = power(ipoint + i) - power(ipoint);
             if pwrdel > del
                 maxpoint = i;
                 del = pwrdel;
             end
          end
          if ~isnan(maxpoint)
             powerupext(ipoint+1:ipoint+maxpoint) = 1;
          end
       end
    end
    
    powererrup = powerupext;
    powererrdn = powerdnext;
    
    je_index = find(powererrup == 1 & powererrdn == -1);
    if ~isempty(je_index)
        numev = 1;
        jevent = [];
        jevent(1,:) = [je_index(1) 1];
        for i = 2:length(je_index)
          if je_index(i) - je_index(i-1) == 1
              jevent(numev,2) = jevent(numev,2) + 1;
          else
              numev = numev + 1;
              jevent(numev,:) = [je_index(i) 1];
          end
        end
        jevent = jevent(jevent(:,2) > 1, :);
        for ievent = 1 : size(jevent, 1)
            eventind = jevent(ievent,1) - 1 : jevent(ievent,1) + jevent(ievent,2);
            if eventind(1)==0
                eventind(1)=[];
            end
            if eventind(end)==npoint+1
                eventind(end)=[];
            end
            if powererrup(eventind(1)) == 1 && powererrdn(eventind(end)) == -1
               del = 0;
               point = eventind(1);
               power0 = power(point);
               for i = 2:length(eventind)
                   if power(eventind(i)) - power0 > del
                       del = power(eventind(i)) - power0;
                       point = eventind(i);
                   end
               end
               powererrup(point:eventind(end)) = NaN(1,eventind(end) - point + 1);
               powererrdn(eventind(1):point) = NaN(1,point - eventind(1) + 1);
               powererrdn(point:eventind(end)) = -ones(1,eventind(end) - point + 1);
               powererrup(eventind(1):point) = ones(1,point - eventind(1) + 1);
            elseif powererrup(eventind(end)) == 1 && powererrdn(eventind(1)) == -1
               del = 0;
               point = eventind(1);
               power0 = power(point);
               for i = 2:length(eventind)
                   if power(eventind(i)) - power0 < del
                       del = power(eventind(i)) - power0;
                       point = eventind(i);
                   end
               end
               powererrup(eventind(1):point) = NaN(1,point - eventind(1) + 1);
               powererrdn(point:eventind(end)) = NaN(1,eventind(end) - point + 1);
               powererrup(point:eventind(end)) = ones(1,eventind(end) - point + 1);
               powererrdn(eventind(1):point) = -ones(1,point - eventind(1) + 1);
               
            end
        end
    end
    
    indexup = [];
    indexdn = [];
    eventup = 0;
    eventdn = 0;
    
    if powererrup(1)==1
        eventup = 1;
        indexup(1,1) = 1;
    end
    if powererrdn(1)==-1
        eventdn = 1;
        indexdn(1,1) = 1;
    end
    
    for i = 2:npoint
        if ~(powererrup(i-1) == 1) && powererrup(i) == 1
            eventup = eventup + 1;
            indexup(eventup,1) = i;
        end
        if powererrup(i-1) == 1 && ~(powererrup(i) == 1)
            indexup(eventup,2) = i-1;
        end
        if ~(powererrdn(i-1) == -1) && powererrdn(i) == -1
            eventdn = eventdn + 1;
            indexdn(eventdn,1) = i;
        end
        if powererrdn(i-1) == -1 && ~(powererrdn(i) == -1)
            indexdn(eventdn,2) = i-1;
        end
    end
    if powererrup(npoint) == 1
        indexup(end,2) = npoint;
    end
    if powererrdn(npoint) == -1
        indexdn(end,2) = npoint;
    end
    for ievent = 1:eventup
        deltaT = (indexup(ievent,2) - indexup(ievent,1))*timestep;
        deltaP = power(indexup(ievent,2)) - power(indexup(ievent,1));
        indexP = (indexup(ievent,2) + indexup(ievent,1))/2;
        ramp(ievent,:,imodel) = [indexP*timestep deltaT deltaP indexup(ievent,:)];
    end
    for ievent = 1:eventdn
        deltaT = (indexdn(ievent,2) - indexdn(ievent,1))*timestep;
        deltaP = power(indexdn(ievent,2)) - power(indexdn(ievent,1));
        indexP = (indexdn(ievent,2) + indexdn(ievent,1))/2;
        ramp(eventup + ievent,:,imodel) = [indexP*timestep deltaT deltaP indexdn(ievent,:)];
    end
    powerderall(:,imodel) = powerder;
    powerupall(:,imodel) = powererrup;
    powerdnall(:,imodel) = powererrdn;
    eventupall(imodel) = eventup;
    eventdnall(imodel) = eventdn;
    sigmaall(imodel) = nanavg(powersigma');
end

if Aggflag
  twrttl = 'twr_{aggr}';
  twrstr = 'twr_aggr';
else
  twrttl = 'twr#1';
  twrstr = 'twr1';
end

if RampFlag && Window ==120 && Thresh == 0.4 && forecast==0 && itwr==1
    
    figure('name','Derivative Method','position',[10 10 1950 950]);
    subplot(2,1,1);
    [AX, H1, H2] = plotyy(dayfr, Power(:,1),dayfr, powerderall(:,1));
    set(H1,'Color','black','linewidth',2)
    set(H2,'Color','blue','linewidth',1)
    set(AX(1), 'FontWeight','bold','FontSize',10,'LineWidth',2,'YColor','black')
    set(AX(2), 'FontWeight','bold','FontSize',10,'LineWidth',2,'XTick',[],'YColor','black','YLim',[-5*Kthresh 5*Kthresh])
    ylabel(AX(1), {'\fontsize{10pt}\bf OBS';'power'});
    ylabel(AX(2), {'\fontsize{7pt}\bf OBS POWER DERIVATIVE'});
    axes(AX(1))
    hold on
    plot(dayfr, Power(:,1), 'sk')
    plot(dayfr(~isnan(powerupall(:,1))),Power(~isnan(powerupall(:,1)),1),'sr')
    plot(dayfr(~isnan(powerdnall(:,1))),Power(~isnan(powerdnall(:,1)),1),'sg')
    plot(dayfr(~isnan(powerdnall(:,1)) & ~isnan(powerupall(:,1))),Power(~isnan(powerdnall(:,1)) & ~isnan(powerupall(:,1)),1),'sc','MarkerSize',12)
    axes(AX(2))
    hold on
    plot([dayfr(1)-10 dayfr(end)],[Kthresh Kthresh],'--r','linewidth',1)
    plot([dayfr(1)-10 dayfr(end)],[-Kthresh -Kthresh],'--r','linewidth',1)
    title({['\fontsize{14pt}\rm ' twrttl '   \fontsize{12pt} Frct' sprintf('%02g',forecast) '   \fontsize{14pt}  RAMP:' num2str(Thresh*100) '% over ' num2str(Window) ' minutes  \fontsize{12pt} windowwidth=' num2str(windowpt)],['\fontsize{10pt}\rm Explicit Dertivative Method Derivative THRESH value = ' num2str(Kthresh)]})
    datetick(AX(1),'x','ddmmm','keepticks')
    axes('Position',[0.89 0.7 0.2 0.2],'visible','off');
    text(0.25,1.25,['\fontsize{14pt}\bf' num2str(eventupall(1))],'color','r')
    text(0.25,1.1,['\fontsize{14pt}\bf' num2str(eventdnall(1))],'color','g')
    grid on

    subplot(2,1,2)
    [AX, H1, H2] = plotyy(dayfr, Power(:,2),dayfr, powerderall(:,2));
    set(H1,'Color','black','linewidth',2)
    set(H2,'Color','blue','linewidth',1)
    set(AX(1), 'FontWeight','bold','FontSize',10,'LineWidth',2,'YColor','black')
    set(AX(2), 'FontWeight','bold','FontSize',10,'LineWidth',2,'XTick',[],'YColor','black','YLim',[-5*Kthresh 5*Kthresh])
    ylabel(AX(1), {'\fontsize{10pt}\bf Model';'power'});
    ylabel(AX(2), '\fontsize{7pt}\bf MODEL POWER DERIVATIVE');
    axes(AX(1))
    hold on
    plot(dayfr, Power(:,2), 'sk')
    plot(dayfr(~isnan(powerupall(:,2))),Power(~isnan(powerupall(:,2)),2),'sr')
    plot(dayfr(~isnan(powerdnall(:,2))),Power(~isnan(powerdnall(:,2)),2),'sg')
    plot(dayfr(~isnan(powerdnall(:,2)) & ~isnan(powerupall(:,2))),Power(~isnan(powerdnall(:,2)) & ~isnan(powerupall(:,2)),2),'sc','MarkerSize',12)
    axes(AX(2))
    hold on
    plot([dayfr(1)-10 dayfr(end)],[Kthresh Kthresh],'--r','linewidth',1)
    plot([dayfr(1)-10 dayfr(end)],[-Kthresh -Kthresh],'--r','linewidth',1)
    datetick(AX(1),'x','ddmmm','keepticks')
    axes('Position',[0.9 0.4 0.2 0.2],'visible','off');
    text(0.25,0.4,['\fontsize{14pt}\bf' num2str(eventupall(2))],'color','r')
    text(0.25,0.25,['\fontsize{14pt}\bf' num2str(eventdnall(2))],'color','g')
    grid on

    saveas(gcf,[path2 '\Timeseries_rampderivative_' num2str(Thresh*100) 'in' num2str(Window) '_' twrstr '_frct' sprintf('%02g',forecast) '.jpg'])
    close gcf
end