function WindCtrl = Read_All_Towers_ModelData(path, forecast, ntwr)
% read text files with model data in Forecast Run method format

files = dir([path '*.txt']);
WindCtrl =[];
for i = 1:length(files)
   if ~isempty(findstr(['frct' sprintf('%02g',forecast)],files(i).name ))
       fid=fopen([path files(i).name],'r');
       h1 = fgets(fid);
       if ~isempty(findstr(h1,'TOWER')) || ~isempty(findstr(h1,'SODAR'))
           for j = 1:3+ntwr
             tline = fgets(fid); 
           end
           header = fgets(fid);
       else
           header = h1;
       end
       while ischar(header) 
           Date = [str2num(header(1:4)) str2num(header(5:7)) str2num(header(8:9)) str2num(header(10:11))];
           Date(3) = Date(3) + forecast;
           if Date(3) > 23
              Date(3) = Date(3) - 24;
              Date(2) = Date(2) + 1;
           end
           formatSpec = '%*s%f';
           cellscan = cell2mat(textscan(fid, formatSpec, ntwr));
           WindCtrl = [WindCtrl; Date cellscan'];

           fgets(fid);
           header = fgets(fid);
       end
   end
   fclose all;
end