function [yfit,k,b,sigma] = derivative(x,y)


n = length(x);
a11 = 0;
a12 = 0;
a21 = 0;
a22 = 0;
b1 = 0;
b2 = 0;
delta = 0;
delta1 = 0;
delta2 = 0;
sigma = 0;
yfit =[];
sigma = 0;
k = NaN;
b = NaN;

for i = 1:n
    a11 = a11 + x(i)*x(i);
    a12 = a12 + x(i);
    a21 = a12;
    a22 = a22 + 1;
    b1 = b1 + x(i)*y(i);
    b2 = b2 + y(i);
end

delta = a11*a22 - a12*a21;
delta1 = b1*a22 - b2*a12;
delta2 = b2*a11 - b1*a21;

if abs(delta) < 1e-6
    return
end

k = delta1/delta;
b = delta2/delta;

for i=1:n
    sigma = sigma + (y(i) -k*x(i) -b)^2;
    yfit(i) = k*x(i) + b;
end

if n > 0 && sigma > 0
    sigma = sqrt(sigma/n);
end